Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkPyramid Class Reference

`#include <vtkPyramid.h>`

Inheritance diagram for vtkPyramid:

[legend]
Collaboration diagram for vtkPyramid:

[legend]
List of all members.

## Detailed Description

a 3D cell that represents a linear pyramid

Date:
  2003/01/06 20:36:14

Revision:
  1.26

vtkPyramid is a concrete implementation of vtkCell to represent a 3D pyramid. A pyramid consists of a rectangular base with four triangular faces. vtkPyramid uses the standard isoparametric shape functions for a linear pyramid. The pyramid is defined by the five points (0-4) where (0,1,2,3) is the base of the pyramid which, using the right hand rule, forms a quadrilaterial whose normal points in the direction of the pyramid apex at vertex #4.

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (80%)
  - Geveci, Berk (7%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkPyramid.h)`
  - .`cxx` (`/Common/vtkPyramid.cxx)`

Examples:
  vtkPyramid (Examples)

Tests:
  vtkPyramid (Tests)

Definition at line 58 of file vtkPyramid.h.

## [NOHEADER]
int | JacobianInverse (float pcoords[3], double **inverse, float derivs[15])
void | InterpolationFunctions (float pcoords[3], float weights[5])
void | InterpolationDerivs (float pcoords[3], float derivs[15])
int * | GetEdgeArray (int edgeId)
int * | GetFaceArray (int faceId)
## Public Types
typedef vtkCell3D | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
int | GetParametricCenter (float pcoords[3])
virtual void | GetEdgePoints (int edgeId, int *&pts)
virtual void | GetFacePoints (int faceId, int *&pts)
virtual float * | GetParametricCoords ()
int | GetCellType ()
int | GetCellDimension ()
int | GetNumberOfEdges ()
int | GetNumberOfFaces ()
vtkCell * | GetEdge (int edgeId)
vtkCell * | GetFace (int faceId)
int | CellBoundary (int subId, float pcoords[3], vtkIdList *pts)
void | Contour (float value, vtkDataArray *cellScalars, vtkPointLocator *locator, vtkCellArray *verts, vtkCellArray *lines, vtkCellArray *polys, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd)
int | EvaluatePosition (float x[3], float *closestPoint, int &subId, float pcoords[3], float &dist2, float *weights)
void | EvaluateLocation (int &subId, float pcoords[3], float x[3], float *weights)
int | IntersectWithLine (float p1[3], float p2[3], float tol, float &t, float x[3], float pcoords[3], int &subId)
int | Triangulate (int index, vtkIdList *ptIds, vtkPoints *pts)
void | Derivatives (int subId, float pcoords[3], float *values, int dim, float *derivs)
## Static Public Methods
int | IsTypeOf (const char *type)
vtkPyramid * | SafeDownCast (vtkObject *o)
vtkPyramid * | New ()
## Protected Methods
| vtkPyramid ()
| ~vtkPyramid ()
## Protected Attributes
vtkLine * | Line
vtkTriangle * | Triangle
vtkQuad * | Quad

## Member Typedef Documentation

typedef vtkCell3D vtkPyramid::Superclass

| Reimplemented from vtkCell3D. Definition at line 61 of file vtkPyramid.h.

## Constructor & Destructor Documentation

vtkPyramid::vtkPyramid | ( |  | ) | `[protected]`

vtkPyramid::~vtkPyramid | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkPyramid::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkCell3D.

int vtkPyramid::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkCell3D.

virtual int vtkPyramid::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkCell3D.

vtkPyramid* vtkPyramid::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkCell3D.

vtkPyramid* vtkPyramid::New | ( |  | ) | `[static]`

| Create an instance of this class. Reimplemented from vtkObject.

virtual void vtkPyramid::GetEdgePoints | ( | int | edgeId,
|  | int *& | pts
| ) | `[virtual]`

| See vtkCell3D API for description of these methods. Implements vtkCell3D.

virtual void vtkPyramid::GetFacePoints | ( | int | faceId,
|  | int *& | pts
| ) | `[virtual]`

| See vtkCell3D API for description of these methods. Implements vtkCell3D.

virtual float* vtkPyramid::GetParametricCoords | ( |  | ) | `[virtual]`

| See vtkCell3D API for description of these methods. Reimplemented from vtkCell3D.

int vtkPyramid::GetCellType | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 75 of file vtkPyramid.h. References VTK_PYRAMID.

int vtkPyramid::GetCellDimension | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Reimplemented from vtkCell3D. Definition at line 76 of file vtkPyramid.h.

int vtkPyramid::GetNumberOfEdges | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 77 of file vtkPyramid.h.

int vtkPyramid::GetNumberOfFaces | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 78 of file vtkPyramid.h.

vtkCell* vtkPyramid::GetEdge | ( | int | edgeId | ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

vtkCell* vtkPyramid::GetFace | ( | int | faceId | ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

int vtkPyramid::CellBoundary | ( | int | subId,
|  | float | pcoords[3],
|  | vtkIdList * | pts
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

void vtkPyramid::Contour | ( | float | value,
|  | vtkDataArray * | cellScalars,
|  | vtkPointLocator * | locator,
|  | vtkCellArray * | verts,
|  | vtkCellArray * | lines,
|  | vtkCellArray * | polys,
|  | vtkPointData * | inPd,
|  | vtkPointData * | outPd,
|  | vtkCellData * | inCd,
|  | vtkIdType | cellId,
|  | vtkCellData * | outCd
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

int vtkPyramid::EvaluatePosition | ( | float | x[3],
|  | float * | closestPoint,
|  | int & | subId,
|  | float | pcoords[3],
|  | float & | dist2,
|  | float * | weights
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

void vtkPyramid::EvaluateLocation | ( | int & | subId,
|  | float | pcoords[3],
|  | float | x[3],
|  | float * | weights
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

int vtkPyramid::IntersectWithLine | ( | float | p1[3],
|  | float | p2[3],
|  | float | tol,
|  | float & | t,
|  | float | x[3],
|  | float | pcoords[3],
|  | int & | subId
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

int vtkPyramid::Triangulate | ( | int | index,
|  | vtkIdList * | ptIds,
|  | vtkPoints * | pts
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

void vtkPyramid::Derivatives | ( | int | subId,
|  | float | pcoords[3],
|  | float * | values,
|  | int | dim,
|  | float * | derivs
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

int vtkPyramid::GetParametricCenter | ( | float | pcoords[3] | ) | `[inline, virtual]`

| Return the center of the pyramid in parametric coordinates. Reimplemented from vtkCell. Definition at line 125 of file vtkPyramid.h.

void vtkPyramid::InterpolationFunctions | ( | float | pcoords[3],
|  | float | weights[5]
| ) | `[static]`

| Pyramid specific methods for computing interpolation functions and derivatives.

void vtkPyramid::InterpolationDerivs | ( | float | pcoords[3],
|  | float | derivs[15]
| ) | `[static]`

int vtkPyramid::JacobianInverse | ( | float | pcoords[3],
|  | double ** | inverse,
|  | float | derivs[15]
| ) |

int* vtkPyramid::GetEdgeArray | ( | int | edgeId | ) | `[static]`

int* vtkPyramid::GetFaceArray | ( | int | faceId | ) | `[static]`

## Member Data Documentation

vtkLine* vtkPyramid::Line`[protected]`

| Definition at line 116 of file vtkPyramid.h.

vtkTriangle* vtkPyramid::Triangle`[protected]`

| Definition at line 117 of file vtkPyramid.h.

vtkQuad* vtkPyramid::Quad`[protected]`

| Definition at line 118 of file vtkPyramid.h.

The documentation for this class was generated from the following file:

- Common/vtkPyramid.h